try:
    import amp
except ImportError:
   print "Could not connect to c++ amplifiersettings class" 


class CommandHandler:

    def __init__(self):
        self.ampInstance = amp.AmplifierSetting()
        self.commands = {
                'SetLeftClipping': self.SetLeftClipping,
                'SetRightClipping': self.SetRightClipping,
                'SetLeftInputDC': self.SetLeftInputDC,
                'SetRightInputDC': self.SetRightInputDC,
                'SetLeftOutputDC': self.SetLeftOutputDC,
                'SetRightOutputDC': self.SetRightOutputDC,
                'SetThermalError': self.SetThermalError,
                'Set15VoltError': self.Set15VoltError,
                'SetIVError': self.SetIVError,
                'SetBruteVoltError': self.SetBruteVoltError
                }


    def RunCommand(self, cmd, params):
        self.commands[cmd](params)

    def SetLeftClipping(self,state):
        state = int(state.strip())
        self.ampInstance.SetLeftClipping(state)

    def SetRightClipping(self, state):
        state = int(state.strip())
        self.ampInstance.SetRightClipping(state)

    def SetLeftInputDC(self, state):
        state = int(state.strip())
        self.ampInstance.SetLeftInputDC(state)

    def SetLeftInputDC(self, state):
        state = int(state.strip())
        self.ampInstance.SetLeftInputDC(state)
        
    def SetRightInputDC(self, state):
        state = int(state.strip())
        self.ampInstance.SetRightInputDC(state)

    def SetLeftOutputDC(self, state):
        state = int(state.strip())
        self.ampInstance.SetLeftOutputDC(state)
        
    def SetRightOutputDC(self, state):
        state = int(state.strip())
        self.ampInstance.SetRightOutputDC(state)

    def SetThermalError(self, state):
        state = int(state.strip())
        self.ampInstance.SetThermalError(state)

    def Set15VoltError(self, case, state):
        state = int(state.strip())
        self.ampInstance.Set15VoltError(state)

    def SetIVError(self, case, state):
        state = int(state.strip())
        self.ampInstance.SetIVError(state)

    def SetBruteVoltError(self, case, state):
        state = int(state.strip())
        self.ampInstance.SetBruteVoltError(state)

        

