import inspect

import libpylogger
global log

log = libpylogger.Logger()


def setup(file_name, directory):
    header = "Amplifier"
    size = 4*(10**5)
    log.setup( file_name, size, libpylogger.LogLevel.BL_LOG_DEBUG, libpylogger.LogLevel.BL_LOG_DEBUG, directory, header)


def bllogger(level, message):
    if level.lower() == 'debug':
        log_level = libpylogger.LogLevel.BL_LOG_DEBUG
    elif level.lower() == 'info':
        log_level = libpylogger.LogLevel.BL_LOG_INFO
    elif level.lower() == 'warn':
        log_level = libpylogger.LogLevel.BL_LOG_WARN
    elif level.lower() == 'err':
        log_level = libpylogger.LogLevel.BL_LOG_ERR
    elif level.lower() == 'fatal':
        log_level = libpylogger.LogLevel.BL_LOG_FATAL
    else:
        print "Invalid Log Level"
        return "Invalid Log Level"


    callerframerecord = inspect.stack()[1]  #change this to 1 for the caller stack
    frame = callerframerecord[0]
    info = inspect.getframeinfo(frame)
    log.log(info.filename,info.function, log_level, message, info.lineno)
