import boto
import boto.s3

import os
import sys

def main():
    if len(sys.argv) < 4:
        print 'Usage: upload_dir_to_s3.py <unit_serial> <crash_log_dir> <crash_dir_name> <type>'
        sys.exit(-1)

    # Check if we're offline
    #offline = os.system('diff /writeable/interfaces /writeable/interfaces_dhcp')
    #if offline != 0:
    #    print 'The system is offline, won\'t attempt to upload logs.'
    #    sys.exit(-1)

    # User access information for 2120controlpoint
    AWS_ACCESS_KEY_ID = 'AKIAJ6IGE2SQD7AZLXKA'
    AWS_ACCESS_KEY_SECRET = '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'

    # destination bucket name
    bucket_name = 'amp-amplifier-crashlogs'

    # unit serial number
    unit_serial = sys.argv[1]

    # source directory
    source_dir = sys.argv[2] + '/' + sys.argv[3] + '/'

    # destination directory name (on s3)
    name = ''
    type = sys.argv[4]
    if type == 'cp':
        name = 'control_point'
    elif type == 'renderer':
        name = 'renderer'
    elif type == 'mediaserver':
        name = 'mediaserver'
    elif type == 'amp':
        name = 'amplifier'
    else:
        print 'Invalid application type, must be cp or renderer'
        sys.exit(-1)

    dest_dir = name + '/' + unit_serial + '/' + sys.argv[3]

    os.system('dmesg > ' + source_dir + '/dmesg.log')

    conn = boto.connect_s3(AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY_SECRET)

    try:
        bucket = conn.create_bucket(bucket_name, location=boto.s3.connection.Location.DEFAULT)
    except Exception, e:
        print 'Amazon refused our connection request: ', str(e)
        body = e.body
        server_time = body.split("<ServerTime>", 1)[1]
        server_time = server_time.split("</ServerTime>", 1)[0]
        print "Setting current time to server time: ", server_time # format is: 2016-01-28T00:14:22Z

        import time
        server_time_obj = time.strptime(server_time, "%Y-%m-%dT%H:%M:%SZ")
        busybox_date_str = time.strftime("%m%d%H%M%Y", server_time_obj) #busybox fmt: 010100002000 (MMDDhhmmYYYY)

        os.system('date ' + busybox_date_str)
        print "Date set, trying again..."
        bucket = conn.create_bucket(bucket_name, location=boto.s3.connection.Location.DEFAULT)
    
    upload_filenames = []
    for (source_dir, dirname, filename) in os.walk(source_dir):
        upload_filenames.extend(filename)
        break

    for filename in upload_filenames:
        sourcepath = os.path.join(source_dir + filename)
        destpath = os.path.join(dest_dir, filename)
        print 'Uploading file \'%s\' to Amazon S3 bucket \'%s\'' % (sourcepath, bucket_name)

        k = boto.s3.key.Key(bucket)
        k.key = destpath
        k.set_contents_from_filename(sourcepath)

if __name__ == '__main__':
    main()
