var trans_table = document.getElementById("trans_table").tBodies[0];
var fatal_table = document.getElementById("fatal_table").tBodies[0];

var refresh_time = 1000;
//TODO Get rid of individual setTimeout and have one that happens with all the functions
function UpdateTables(table, endpoint) {
        $.ajax({
            url: endpoint,
            type: 'GET',
            dataType: 'json',
            success: function(json){
                var newTable = document.createElement('tbody');
                $.each(json.errors, function(error, time) {
                    var newRow = newTable.insertRow(0);
                    var cell1 = newRow.insertCell(0);
                    var cell2 = newRow.insertCell(1);
                    cell1.innerHTML=error;
                    cell2.innerHTML=time;
                    //console.log('Value of ' + error + 'is: ' + time);
                });
                if (Object.keys(json.errors).length) {
                    console.log(table, endpoint);
                    console.log(table.parentNode);
                    table.parentNode.replaceChild(newTable, table);
                    setTimeout(UpdateTables.bind(null, newTable,  endpoint), refresh_time); 
                }
                else {
                    setTimeout(UpdateTables.bind(null, table, endpoint), refresh_time); 
                }

            },
        error: function() {
            console.log('no json response');
            setTimeout(UpdateTables.bind(null, table, endpoint), refresh_time); 
        }
        });
};

function UpdateTemp() {
        $.get('/ajax/temperature', function(data){
           temp = parseInt(data.temp).toFixed(1)
           $('#temp').text(temp+" ºC");
        });
        setTimeout(UpdateTemp, refresh_time);
};

function UpdateMains() {
        $.get('/ajax/mains', function(data){
           $('#mains').text(data['mains_state']);
        });
        setTimeout(UpdateMains, refresh_time);
};

function UpdatePowerButton() {
        $.get('/ajax/power_on', function(data){
            power_state = data['power_state'] ;
            console.log(power_state);
            if (power_state) { 
                $('#power_button').text("Turn Off");
            } else {
                $('#power_button').text("Turn On");
            }

        });
        setTimeout(UpdatePowerButton, refresh_time);
};
UpdateTables(fatal_table, '/ajax/fatal_errors');
UpdateTables(trans_table, '/ajax/trans_errors');
UpdateTemp();
UpdateMains();
UpdatePowerButton();
